com.jnape.palatable.lambda.functions.builtin.fn2

## Class Into3<A,B,C,D>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn2.Into3<A,B,C,D>

- Type Parameters:
    `A` - the first argument type
    `B` - the second argument type
    `C` - the third argument type
    `D` - the result type
  All Implemented Interfaces:
    Fn1<Fn3<? super A,? super B,? super C,? extends D>,Fn1<Product3<A,B,C>,D>>, Fn2<Fn3<? super A,? super B,? super C,? extends D>,Product3<A,B,C>,D>, Applicative<Fn1<Product3<A,B,C>,D>,Fn1<Fn3<? super A,? super B,? super C,? extends D>,?>>, Cartesian<Fn3<? super A,? super B,? super C,? extends D>,Fn1<Product3<A,B,C>,D>,Fn1<?,?>>, Cocartesian<Fn3<? super A,? super B,? super C,? extends D>,Fn1<Product3<A,B,C>,D>,Fn1<?,?>>, Contravariant<Fn3<? super A,? super B,? super C,? extends D>,Profunctor<?,Fn1<Product3<A,B,C>,D>,Fn1<?,?>>>, Functor<Fn1<Product3<A,B,C>,D>,Fn1<Fn3<? super A,? super B,? super C,? extends D>,?>>, Profunctor<Fn3<? super A,? super B,? super C,? extends D>,Fn1<Product3<A,B,C>,D>,Fn1<?,?>>, Monad<Fn1<Product3<A,B,C>,D>,Fn1<Fn3<? super A,? super B,? super C,? extends D>,?>>, MonadReader<Fn3<? super A,? super B,? super C,? extends D>,Fn1<Product3<A,B,C>,D>,Fn1<Fn3<? super A,? super B,? super C,? extends D>,?>>, MonadRec<Fn1<Product3<A,B,C>,D>,Fn1<Fn3<? super A,? super B,? super C,? extends D>,?>>, MonadWriter<Fn3<? super A,? super B,? super C,? extends D>,Fn1<Product3<A,B,C>,D>,Fn1<Fn3<? super A,? super B,? super C,? extends D>,?>>

      public final class Into3<A,B,C,D>
      extends Object
      implements Fn2<Fn3<? super A,? super B,? super C,? extends D>,Product3<A,B,C>,D>

  Given an ``Fn3`<A, B, C, D>` and a ``Product3`<A, B, C>`, destructure the product and apply the slots as arguments to the function, returning the result.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Into3()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `D` | `checkedApply(Fn3<? super A,? super B,? super C,? extends D> fn, Product3<A,B,C> product)`
    `static <A,B,C,D> Into3<A,B,C,D>` | `into3()`
    `static <A,B,C,D> Fn1<Product3<A,B,C>,D>` | `into3(Fn3<? super A,? super B,? super C,? extends D> fn)`
    `static <A,B,C,D> D` | `into3(Fn3<? super A,? super B,? super C,? extends D> fn, Product3<A,B,C> product)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `apply, apply, checkedApply, compose, contraMap, curried, curry, diMapL, discardR, flip, fn2, fromBiFunction, toBiFunction, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Constructor Detail

    - #### Into3

          public Into3()

  - ### Method Detail

    - #### checkedApply

          public D checkedApply(Fn3<? super A,? super B,? super C,? extends D> fn,
                                Product3<A,B,C> product)

      Specified by:
        `checkedApply` in interface `Fn2<Fn3<? super A,? super B,? super C,? extends D>,Product3<A,B,C>,D>`

    - #### into3

          public static <A,B,C,D> Into3<A,B,C,D> into3()

    - #### into3

          public static <A,B,C,D> Fn1<Product3<A,B,C>,D> into3(Fn3<? super A,? super B,? super C,? extends D> fn)

    - #### into3

          public static <A,B,C,D> D into3(Fn3<? super A,? super B,? super C,? extends D> fn,
                                          Product3<A,B,C> product)